﻿Imports System.Threading.Tasks

Namespace Core

	''' <summary>
	''' Functionality extracted from the SystemUnderTestHubleObject.
	''' </summary>
	Public Class Functionality
		Private throwExceptionFlag As Boolean

		Public Sub Init()
			Me.Message = "Init"
		End Sub

		Public Sub Do1()
			' sometimes the asynchronous operation throws an exceptions 
			If throwExceptionFlag Then
                Throw New Exception
			End If

			Me.Message &= " Work"
		End Sub

		Public Sub Do2(ByVal taskStatus As TaskStatus)
			If taskStatus = TaskStatus.RanToCompletion Then
				Me.Message &= " OK"
			End If
			If taskStatus = TaskStatus.Faulted Then
				Me.Message &= " NOK"
			End If
		End Sub

		Public Sub DoRecurring()
			If throwExceptionFlag Then
                Throw New Exception
			End If

			Me.Message &= " Poll"
		End Sub

        Private PrivateMessage As String
        Public Property Message As String
            Get
                Return PrivateMessage
            End Get
            Private Set(ByVal value As String)
                PrivateMessage = value
            End Set
        End Property

		Public Sub PrepareToThrowException()
			throwExceptionFlag = True
		End Sub
	End Class
End Namespace
