﻿Imports System.Diagnostics.Contracts

Namespace Core

	<ContractClass(GetType(TimerContracts))>
	Public Interface ITimer
		<Pure>
		Function IsStarted() As Boolean

		Sub StartTimer(ByVal action As Action, ByVal interval As TimeSpan)

		Sub StopTimer()
	End Interface

	<ContractClassFor(GetType(ITimer))>
	Public MustInherit Class TimerContracts
		Implements ITimer
		Public MustOverride Function IsStarted() As Boolean Implements ITimer.IsStarted

		Public Sub StartTimer(ByVal action As Action, ByVal interval As TimeSpan) Implements ITimer.StartTimer
            Contract.Requires((Not Me.IsStarted))
            Contract.Requires(interval > New TimeSpan)
		End Sub

		Public Sub StopTimer() Implements ITimer.StopTimer
            Contract.Ensures((Not Me.IsStarted))
		End Sub
	End Class
End Namespace