﻿Imports System.Threading

Namespace Core

	''' <summary>
	''' Adapter for for the System.Threading.Timer.
	''' </summary>
	Public Class SystemThreadingTimerAdapter
		Implements ITimer
		Private innerTimer As Timer
		Private timerAction As Action

		Public Function IsStarted() As Boolean Implements ITimer.IsStarted
			Return innerTimer IsNot Nothing
		End Function

		Public Sub StartTimer(ByVal action As Action, ByVal interval As TimeSpan) Implements ITimer.StartTimer
			timerAction = action
			innerTimer = New Timer(AddressOf TimerCallback,Nothing,interval,interval)
		End Sub

		Public Sub StopTimer() Implements ITimer.StopTimer
			innerTimer.Change(Timeout.Infinite, Timeout.Infinite)
			innerTimer = Nothing
		End Sub

		Private Sub TimerCallback(ByVal state As Object)
			timerAction()
		End Sub
	End Class
End Namespace
