﻿Imports System.Timers

Namespace Core

	''' <summary>
	''' Adapter for for the System.Timers.Timer.
	''' </summary>
	Public Class SystemTimersTimerAdapter
		Implements ITimer
		Private innerTimer As Timer
		Private timerAction As Action

		Public Function IsStarted() As Boolean Implements ITimer.IsStarted
			Return innerTimer IsNot Nothing AndAlso innerTimer.Enabled
		End Function

		Public Sub StartTimer(ByVal action As Action, ByVal interval As TimeSpan) Implements ITimer.StartTimer
			timerAction = action
			innerTimer = New Timer(interval.TotalMilliseconds)
			AddHandler innerTimer.Elapsed, AddressOf innerTimer_Elapsed
			innerTimer.Start()
		End Sub

		Public Sub StopTimer() Implements ITimer.StopTimer
			If innerTimer IsNot Nothing Then
				innerTimer.Stop()
				innerTimer = Nothing
			End If
		End Sub

		Private Sub innerTimer_Elapsed(ByVal sender As Object, ByVal e As ElapsedEventArgs)
			timerAction()
		End Sub
	End Class
End Namespace
