﻿Imports System.Threading
Imports System.Threading.Tasks

Namespace Core

	''' <summary>
	''' A class that either starts new threads directly or 
	''' uses timers to to start threads indirectly.
	''' This version calls a dependetn object when
	''' asynchronous operations are completed. 
	''' </summary>
	Public Class SystemUnderTestDependent
		Private rawTimer As Timer
		Private ReadOnly dependent As ISomeInterface
		Private throwExceptionFlag As Boolean

		Public Sub New(ByVal dependent As ISomeInterface)
			Me.dependent = dependent
		End Sub

		''' <summary>
		''' Start asynchronous operation with call to dependent object
		''' </summary>
		Public Sub StartAsynchronousOperation()
			Me.Message = "Init"

				' sometimes the asynchronous operation throws an exceptions 
				' The asynchronous operation is finished
            Task.Run(Sub()
                         If throwExceptionFlag Then
                             Throw New Exception
                         End If
                         Thread.Sleep(1000)
                         Message &= " Work"
                         dependent.DoMore()
                     End Sub)
		End Sub

		Public Sub StartRecurring()
			' here goes any initialization
			Me.Message = "Init"

					' sometimes the asynchronous operation throws an exceptions 
					' The asynchronous operation is finished
            rawTimer = New Timer(Sub(o)
                                     If throwExceptionFlag Then
                                         Throw New Exception
                                     End If
                                     Message &= " Poll"
                                     dependent.DoMore()
                                 End Sub, Nothing, New TimeSpan(0, 0, 0, 1), New TimeSpan(0, 0, 0, 1))
		End Sub

		Public Sub StopRecurring()
			rawTimer.Change(Timeout.Infinite, Timeout.Infinite)
			rawTimer = Nothing
		End Sub

        Private PrivateMessage As String
        Public Property Message As String
            Get
                Return PrivateMessage
            End Get
            Private Set(ByVal value As String)
                PrivateMessage = value
            End Set
        End Property

		Public Sub PrepareToThrowException()
			throwExceptionFlag = True
		End Sub
	End Class
End Namespace
