﻿Imports System.Threading
Imports System.Threading.Tasks

Namespace Core

	''' <summary>
	''' A class that either starts an asynchronous operation directly or 
	''' uses timers to start an asynchronous operation indirectly. This is
	''' the initial version which is lacks any testability support.
	''' </summary>
	Public Class SystemUnderTestInitial
		Private timer As Timer
        Private ReadOnly lockObject As New Object

		''' <summary>
		''' Start asynchronous operation without any testability support
		''' </summary>
		Public Sub StartAsynchronousOperation()
			' here goes any initialization
			Me.Message = "Init"

			Task.Run(Sub()
				Thread.Sleep(1500)
				Message &= " Work"
			End Sub)
		End Sub

		Public Sub StartRecurring()
			Me.Message = "Init"

			' Set up timer with 1 sec delay and 1 sec interval.
			Me.timer = New Timer(Sub(o)
				SyncLock lockObject
					Message &= " Poll"
				End SyncLock
			End Sub, Nothing, New TimeSpan(0, 0, 0, 1), New TimeSpan(0, 0, 0, 1))
		End Sub

		Public Sub StopRecurring()
			Me.timer.Change(Timeout.Infinite, Timeout.Infinite)
			Me.timer = Nothing
		End Sub

        Private PrivateMessage As String
        Public Property Message As String
            Get
                Return PrivateMessage
            End Get
            Private Set(ByVal value As String)
                PrivateMessage = value
            End Set
        End Property

	End Class
End Namespace
