﻿Imports System.Windows.Threading

Namespace Core

	''' <summary>
	''' A class that uses a DispatcherTimer (WPF) to start an asynchronous operation indirectly. This is
	''' the initial version which is lacks any testability support.
	''' </summary>
	Public Class SystemUnderTestInitialWithDispatcherTimer
		Private timer As DispatcherTimer
        Private ReadOnly lockObject As New Object

		Public Sub StartRecurring()
			Me.Message = "Init"

			' Set up timer with 1 sec interval.
            Me.timer = New DispatcherTimer
			timer.Interval = TimeSpan.FromSeconds(1)
			AddHandler timer.Tick, Sub(o, e)
				SyncLock lockObject
					Message &= " Poll"
				End SyncLock
			End Sub
			timer.Start()
		End Sub

		Public Sub StopRecurring()
			If timer IsNot Nothing Then
				If timer.IsEnabled Then
					timer.Stop()
				End If
				timer = Nothing
			End If
		End Sub

        Private PrivateMessage As String
        Public Property Message As String
            Get
                Return PrivateMessage
            End Get
            Private Set(ByVal value As String)
                PrivateMessage = value
            End Set
        End Property

	End Class
End Namespace
