﻿Imports NUnit.Framework
Imports System.Threading.Tasks
Imports Core


Namespace Tests

	''' <summary>
	''' Testing the Functionality class independent of the SystemUnderTestHumbleObject class.
	''' </summary>
	<TestFixture>
	Public Class TestsSolution1Functionality
		Private functionality As Functionality

		<SetUp>
		Public Sub SetUp()
            functionality = New Functionality
		End Sub

		<Test>
		Public Sub TestInitFunctiality()
			' Execute
			functionality.Init()

			' Assert
			Assert.AreEqual("Init", functionality.Message)
		End Sub

		<Test>
		Public Sub TestDo1Functiality()
			' Execute
			functionality.Do1()

			' Assert
			Assert.AreEqual(" Work", functionality.Message)
		End Sub

		<Test>
		Public Sub TestDo1FunctialityWithExeception()
			' Setup
			functionality.PrepareToThrowException()

			' Execute, Assert
            Assert.That(Sub() functionality.Do1(), Throws.TypeOf(Of Exception))
		End Sub

		<Test>
		Public Sub TestDo2FunctialityOk()
			' Execute
			functionality.Do2(TaskStatus.RanToCompletion)

			' Assert
			Assert.AreEqual(" OK", functionality.Message)
		End Sub

		<Test>
		Public Sub TestDo2FunctialityNok()
			' Execute
			functionality.Do2(TaskStatus.Faulted)

			' Assert
			Assert.AreEqual(" NOK", functionality.Message)
		End Sub

		<Test>
		Public Sub TestDoRecurringFunctiality()
			' Execute
			functionality.DoRecurring()

			' Assert
			Assert.AreEqual(" Poll", functionality.Message)
		End Sub

		<Test>
		Public Sub TestDoRecurringFunctialityWithExeception()
			' Setup
			functionality.PrepareToThrowException()

			' Execute, Assert
            Assert.That(Sub() functionality.DoRecurring(), Throws.TypeOf(Of Exception))
		End Sub

	End Class
End Namespace
