﻿Imports NUnit.Framework
Imports Core
Imports System.Threading.Tasks

Namespace Tests




	''' <summary>
	''' Testing the functionality of the SystemUnderTestHumbleLight via methods,
	''' which were formerly private. 
	''' </summary>
	<TestFixture>
	Public Class TestsSolution1HumbleLight
		Private sut As SystemUnderTestHumbleLight

		<SetUp>
		Public Sub SetUp()
            sut = New SystemUnderTestHumbleLight
		End Sub

		<Test>
		Public Sub TestInitFunctiality()
			' Execute
			sut.Init()

			' Assert
			Assert.AreEqual("Init", sut.Message)
		End Sub

		<Test>
		Public Sub TestDo1Functiality()
			' Execute
			sut.Do1()

			' Assert
			Assert.AreEqual(" Work", sut.Message)
		End Sub

		<Test>
		Public Sub TestDo1FunctialityWithExeception()
			' Setup
			sut.PrepareToThrowException()

			' Execute, Assert
            Assert.That(Sub() sut.Do1(), Throws.TypeOf(Of Exception))
		End Sub

		<Test>
		Public Sub TestDo2FunctialityOk()
			' Execute
			sut.Do2(TaskStatus.RanToCompletion)

			' Assert
			Assert.AreEqual(" OK", sut.Message)
		End Sub

		<Test>
		Public Sub TestDo2FunctialityNok()
			' Execute
			sut.Do2(TaskStatus.Faulted)

			' Assert
			Assert.AreEqual(" NOK", sut.Message)
		End Sub

		<Test>
		Public Sub TestDoRecurringFunctiality()
			' Execute
			sut.DoRecurring()

			' Assert
			Assert.AreEqual(" Poll", sut.Message)
		End Sub

		<Test>
		Public Sub TestDoRecurringFunctialityWithExeception()
			' Setup
			sut.PrepareToThrowException()

			' Execute, Assert
            Assert.That(Sub() sut.DoRecurring(), Throws.TypeOf(Of Exception))
		End Sub

	End Class
End Namespace
