﻿Imports Core

Imports System.Windows.Threading

Namespace WpfApplication

	''' <summary>
	''' Adapter for for the DispatcherTimer.
	''' </summary>
	Public Class DispatcherTimerAdapter
		Implements ITimer
		Private innerTimer As DispatcherTimer

		Private timerAction As Action

		Public Function IsStarted() As Boolean Implements ITimer.IsStarted
			Return innerTimer IsNot Nothing AndAlso innerTimer.IsEnabled
		End Function

		Public Sub StartTimer(ByVal action As Action, ByVal interval As TimeSpan) Implements ITimer.StartTimer
			timerAction = action
			innerTimer = New DispatcherTimer()
			AddHandler innerTimer.Tick, AddressOf InnerTimerTick
			innerTimer.Interval = interval
			innerTimer.Start()
		End Sub

		Public Sub StopTimer() Implements ITimer.StopTimer
			If innerTimer IsNot Nothing Then
				If innerTimer.IsEnabled Then
					innerTimer.Stop()
				End If
				innerTimer = Nothing
			End If
		End Sub

		Private Sub InnerTimerTick(ByVal sender As Object, ByVal e As EventArgs)
			timerAction()
		End Sub

	End Class
End Namespace
